import { Revokable } from './lifecycle';
export default class EventEmitter<EventMap extends {
    [key in string]: unknown[];
}> {
    protected listeners: Map<keyof EventMap, ((...args: EventMap[any]) => void)[]>;
    on<K extends keyof EventMap>(event: K, listener: (...args: EventMap[K]) => void): Revokable;
    trigger<K extends keyof EventMap>(event: K, ...args: EventMap[K]): void;
}
